##### Activity
# Create a Computing Lesson
Research Activity, Computational Artifact Activity

### AP Computer Science Principles: Learning Objectives:
- [LO 1.2.4] Collaborate in the creation of computational artifacts. [P6]
- [LO 2.1.1] Describe the variety of abstractions used to represent data. [P3]
- [LO 2.3.1] Use models and simulations to represent phenomena. [P3]
- [LO 7.5.1] Access, manage, and attribute information using effective strategies. [P1]
- [LO 7.5.2] Evaluate online and print sources for appropriateness and credibility. [P5]

**Overview for Teachers**
A computing lesson is a computational artifact that teaches others about a computing concept. In this project, students will create artifacts to teach others about a concept of their choice. They will work in pairs and develop ways to represent their chosen concept to an audience with a limited knowledge of computing. Topics can be any computing concept the students are interested in or taken from the AP CS Principles Course Description.

**Example topics:**
* How digital data is stored in binary
* How email works
* What a hardware component in a computer does

For guidance on preparing students for research and creating artifacts, see the Assessment and Activity Guide.

**Day Plan:**
* Day 1: Review research and artifact creation methods, choose a topic. Students should end the class with starting points for their research and a clear topic to pursue.
* Days 2-3: Find articles on the topic, design and build their artifact. Assist students in finding and evaluating research sources. Assist students in choosing an artifact to build and using the tools to build their artifacts.
* Day 4: Class presentations. Lead class discussion with the provided discussion questions. Assign students assessment questions to answer individually.

**What you need:**
* Computers - one for each pair of students

**Overview for Students**

You will be working in pairs to create a computational artifact that teaches others about one of the computing concepts you have learned in class.

**Directions for Students**
1. Find a partner
1. Work together to choose a topic for your computational artifact and the intended audience. For example, they may choose to teach elementary school students about different number systems or grandparents about computer storage hardware. 
1. Research the topic
1. Identify a model or simulation to represent the topic
1. Create the computational artifact
1. Prepare for discussion questions below


### Discussion Questions:
- Describe how you and your partner collaborated to create the computational artifact.
- How does your model/simulation represent the topic you chose to teach others about? How well does it model the phenomenon? What aspects are not modeled well?
- Why did you choose the model you did? How does it fit the intended audience?

### Assessment Questions:
- Pick a portion of your lesson that you and your partner collaborated on. How does this reflect effort from both of you? [EK 1.2.4A]
- While collaborating on this lesson, was there a time when you and your partner disagreed? How did you resolve this disagreement? [EK 1.2.4C]
- What is a portion of the lesson which reflects different perspectives from you and your partner? [EK 1.2.4F]
- How does your model simplify what it represents? [EK 2.3.1A]
- What is something that your model omits? What are the tradeoffs for not including this aspect in your model? [EK 2.3.1C]
- How did you find your research sources for your artifact? [LO 7.5.1]
- Why were your research sources appropriate for your artifact? [EK 7.5.2B]
