##### Activity
# Innovations and Crowdsourcing
Inquiry Activity

### Learning Objectives:
- [LO 1.2.5] Analyze the correctness, usability, functionality, and suitability of computational artifacts.
- [LO 7.1.1] Explain how computing innovations affect communication, interaction, and cognition. [P4]
- [LO 7.1.2] Explain how people participate in a problem-solving process that scales. [P4]

**What computing technologies have affected communication? In what ways?**

Begin discussion by asking students what technologies in the past 30 years or so have had an impact on how society communicates and operates. As technologies are suggested, explore exactly how they have affected society, for example:

* Email
* Video conferencing
* Social media
* Social media
* Cloud computing
* GPS
* Internet

For a full list, see EKs under EU 7.1 in the Course Description.

## What kinds of collaboration does technology enable?

Segue to the topic of worldwide collaboration through technology. Ask for services where collaboration is a feature or even a central piece. Some examples that might be suggested to engender discussion:

- Wikipedia, a collaborative encyclopedia project
- Waze, a service which aggregates and shares traffic data between users
- Microsoft Office and Google Docs real-time collaboration
- Ratings on sites like Amazon, Yelp, Etsy
- News aggregation and rating communities, such as Reddit
- Service which informally share resources, like AirBnB, Getaround
- Open source projects, including CodeCombat and Linux, often through GitHub
- Sharing computational resources, like Electric Sheep and SETI@Home
- Reddit Place, a project for creating a collaboratively generated image

While these services provide great opportunities to collaborate on difficult problems, how these services enable collaboration is a problem in and of itself. The challenges can be technical, societal or psychological.

## How do documents being edited at the same time coordinate their changes?
Discuss source of truth, that is usually a server serves as an arbiter that all other actors must defer to. Multiplayer games also use this. Also mention operational transform, which is a type of algorithm that is often used to coordinate changes on documents being edited in real time.

AirBnB has renters and owners give each other reviews before showing each other those reviews, and then do not allow them to change their responses. Otherwise, one review might affect the other.

## How do you sort reviews or votes?

Some sites have “reviews of reviews” where it will say “x number of customers found this review helpful”. Then, how do you sort items based on reviews? You can’t, for example, simply sort based on the average review, otherwise an item with a single 5-star review will outrank an item with an average 4.5 rating with 500 reviews, even though the latter is more reliable. But you also want to give “new” items a chance. Reddit addresses this by having separate tabs for popular and new items, so users can decide what they’d rather sort for.

Having discussed ways in which various services harness the group to solve problems, now is a good time to discuss what happens to these services when people act in bad faith. What’s the worst thing people could do to disrupt a collaborative system? What is the effect?

- If people post false information on Wikipedia, not all information there is trusted, and the usefulness as a source of information is reduced.
- If people are paid to provide positive but false Amazon or AirBnB reviews, they cannot be trusted, and they are not reliable for deciding what to choose.
- If people use scripts to automatically give some piece of news or product unwarranted attention on Reddit, the group can be manipulated, or simply not able to affect the type of content they want to see.

Having generated a list of collaborative projects or services, have students group up and pick some sort of collaboration and research either how it works or one of the challenges it faces, such as any of those listed above. Have each group present to the rest of the class their findings.

## Zooniverse Activity
Have the students visit the Zooniverse website (https://www.zooniverse.org/projects) and instruct them to participate in multiple citizen science projects. Encourage them to choose a different project each time. After giving them about ten minutes to work on the site, lead a discussion asking students how citizen science projects enable people to:

- Solve problems
- Participate in a project that scales
- Help websites and apps collect data
- Generate knowledge from data

### Discussion Questions:
- What problems do these collaborative services solve?
- How exactly do people participate in these collaborations? What individual actions are people doing, as opposed to the technology involved?
- How do these services manage and coordinate the often huge number of collaborators involved, some of whom are not acting in good faith?
- Which collaborative applications are improved or only possible with mobile devices?
- What are some examples of collaborative output being false or misleading? How can users guard themselves?

### Assessment Questions:
* What are three technologies which have changed or are currently changing how we communicate and collaborate? [EK 7.1.1A, EK 7.1.1B, EK 7.1.1C, EK 7.1.1D]
* What is the impact of having information widely available? [EK 7.1.1E]
* Aside from underpinning car navigation, what is an example way in which GPS is used? [EK 7.1.1I]
* What is crowdsourcing? What is an example of crowdsourcing? [EK 7.1.2F]
* What are some applications that only became possible when mobile devices entered the market? [EK 7.1.2G]
