#### Activity
# Emerging Technology
Research Activity, Computational Artifact Activity
 
#### AP Computer Science Principles: Learning Objectives

- [LO 1.2.2] Create a computational artifact using computing tools and techniques to solve a problem. [P2]
- [LO 1.2.3] Create a new computational artifact by combining or modifying existing artifacts. [P2]
- [LO 7.1.1] Explain how computing innovations affect communication, interaction, and cognition. [P4]
- [LO 7.1.2] Explain how people participate in a problem-solving process that scales. [P4]
- [LO 7.2.1] Explain how computing has impacted innovations in other fields. [P1]
- [LO 7.3.1] Analyze the beneficial and harmful effects of computing. [P4]
- [LO 7.4.1] Explain the connections between computing and real-world contexts, including economic, social, and cultural contexts. [P1]
- [LO 7.5.1] Access, manage, and attribute information using effective strategies. [P1]
- [LO 7.5.2] Evaluate online and print sources for appropriateness and credibility. [P5]
 
**Overview for Teachers**

The emerging technology project is a multi-day project that will allow students to apply what they have previously learned through the creation of a computational artifact. Students will research an emerging technology and create some form of computational artifact to show what the technology is, how it works, and its impact on the world.

For guidance on preparing students for research and creating artifacts, see the Assessment and Activity Guide.

**Day Plan:**
1. Day 1: Review research and artifact creation methods, choose a topic. Students should end the class with starting points for their research and a clear topic to pursue.
1. Days 2-4: Find articles on the topic, design and build their artifact. Assist students in finding and evaluating research sources. Assist students in choosing an artifact to build and using the tools to build their artifacts.
1. Day 5: Class presentations. Lead class discussion with the provided discussion questions. Assign students assessment questions to answer individually.

**What you need:**
* Links to articles describing emerging technologies. You do not have to provide all articles for the students, but it may be helpful to have a few to help guide them. Look at sites such as Forbes, Wired, and Science Daily

**Overview for Students**

They will be researching an emerging technology and analyzing it for impacts on economy, culture, and society.  Following their research, they will create an computational artifact that highlights their findings, and present it to the rest of the class.

**Directions for Students**
1. Find an article about an emerging computing innovation.
1. Research and analyze the innovation and its impacts on the economy, culture, and society. They must find and properly cite additional sources for their research. The students have to discover what the technology is, how it works, and how it could impact users around the world. In particular, they should focus on both the beneficial and harmful effects of the technology.
1. Create a computational artifact that highlights their findings.
1. Present to the rest of the class.

**Discussion questions to use during student presentations, or following as a class discussion:**
- How did you choose the design of your computational artifact? How does it showcase the technology you researched?
- Describe how others could contribute to the technology you found. How could you help to improve it?
- How will this technology impact other fields?
- What are the benefits of this technology? The potential harms? Does that change when looking at people of different age groups, genders, countries, or economic status?
- What kind of trouble did you have finding appropriate sources?

### Assessment Questions:
- What are three technologies which have changed or are currently changing how we communicate? [EK 7.1.1A, EK 7.1.1B, EK 7.1.1C, EK 7.1.1D]
- What is the impact of having information widely available? [EK 7.1.1E]
- Aside from underpinning car navigation, what is an example way in which GPS is used? [EK 7.1.1I]
- What are some applications that only became possible when mobile devices entered the market? [EK 7.1.2G]
- What is machine learning and what is an example application? [EK 7.2.1A]
- How has computing affected an industry or career field? [EK 7.2.1A, EK 7.2.1B]
- What is Moore’s law? [EK 7.2.1F]
- What is an example of a computing innovation which has had positive and negative effects? [LO 7.3.1]
- What is a recent example in the news of a negative outcome due to technology? [LO 7.3.1]
- What is the “digital divide”? [7.4.1D]
- How can you evaluate the credibility of a source? [7.5.2A]
