##### Getting Started
## Frequently Asked Questions

#### Table of Contents
* [What is CodeCombat?](#what-is-codecombat)
* [What ages are appropriate for CodeCombat?](#what-ages-are-appropriate-for-codecombat)
* [What grades are appropriate for CodeCombat?](#what-grades-are-appropriate-for-codecombat)
* [What programing languages are available?](#what-programing-languages-are-available)
* [Can I use CodeCombat as the class’s main curriculum?](#can-i-use-codecombat-as-the-class-s-main-curriculum)
* [How much does it cost to access all of the available courses and resources?](#how-much-does-it-cost-to-access-all-of-the-available-courses-and-resources)
* [What does a license provide?](#what-does-a-license-provide)
* [Do you have any free courses for educators to try before they make their purchasing decision?](#do-you-have-any-free-courses-for-educators-to-try-before-they-make-their-purchasing-decision)
* [Can my students create an account if they have no email address?](#can-my-students-create-an-account-if-they-have-no-email-address)
* [Can I track my student’s progress?](#can-i-track-my-student-s-progress)
* [Does CodeCombat work on an iPad?](#does-codecombat-work-on-an-ipad)
* [Does CodeCombat support Clever Instant Logins?](#does-codecombat-support-clever-instant-logins)
* [Is there a recommended browser and operating system?](#is-there-a-recommended-browser-and-operating-system)
* [Students’ computer science backgrounds vary differently in my class, how does CodeCombat help me with that challenge?](#students-computer-science-backgrounds-vary-differently-in-my-class-how-does-codecombat-help-me-with-that-challenge)
* [What if I need licenses that only last a semester instead of a full year?](#what-if-i-need-licenses-that-only-last-a-semester-instead-of-a-full-year)
* [What is the Arena level at the end of a course?](#what-is-the-arena-level-at-the-end-of-a-course)
* [Does CodeCombat have projects that students can work on and share?](#does-codecombat-have-projects-that-students-can-work-on-and-share)
* [What do you offer in the Web Development and Game Development courses?](#what-do-you-offer-in-the-web-development-and-game-development-courses)
* [Can students skip earlier levels if they already understand the concepts?](#can-students-skip-earlier-levels-if-they-already-understand-the-concepts)
* [Does the teacher need to purchase a license if they want to work through the levels like their students?](#does-the-teacher-need-to-purchase-a-license-if-they-want-to-work-through-the-levels-like-their-students)
* [How do I get started with CodeCombat?](#how-do-i-get-started-with-codecombat)
* [Is there a limit to how many students I can add in Introduction to Computer Science?](#is-there-a-limit-to-how-many-students-i-can-add-in-introduction-to-computer-science)
* [How do I reset my student's password?](#how-do-i-reset-my-student-s-password)
* [How do I transfer a license from one student to another?](#how-do-i-transfer-a-license-from-one-student-to-another)
* [How do I share licenses to other teachers in my organization?](#how-do-i-share-licenses-to-other-teachers-in-my-organization)
* [How do I assess my students’ grasp of concepts?](#how-do-i-assess-my-students-grasp-of-concepts)
* [What is the difference between the two Challenge Level types?](#what-is-the-difference-between-the-two-challenge-level-types)
* [How do I review my students’ level code?](#how-do-i-review-my-students-level-code)
* [Where can I find the solutions to all levels?](#where-can-i-find-the-solutions-to-all-levels)


### What is CodeCombat?
CodeCombat is a coding game that uses real typed code and personalized learning to teach computer science with no teacher training needed.

### What ages are appropriate for CodeCombat?
CodeCombat is recommended for students aged 9 and up.

### What grades are appropriate for CodeCombat?
CodeCombat is recommended for schools with students aged 9 and up, which starts in 4th grade in the US.

### What programing languages are available?
We currently support Python and JavaScript.

**Why should you choose Python?**
Python is both beginner-friendly and currently used by major corporations (such as Google). If you have younger or first-time learners, we strongly recommend Python.

**Why should you choose JavaScript?**
JavaScript is the language of the web and is used across nearly every website. You may prefer to choose JavaScript if you are planning to also study web development.  We’ve also made it easy for students to transition from Python to JavaScript-based web development.

JavaScript’s syntax is a little more difficult for beginners than Python, so if you cannot decide between the two, we recommend Python.

### Can I use CodeCombat as the class’s main curriculum?
Absolutely! We’ve spent time consulting with education specialists to craft classroom curriculum and materials specifically for teachers who are using CodeCombat without any prior computer science experience themselves. Many schools are implementing CodeCombat as the main computer science curriculum.

We’ve published a set of curriculum resources in our [Resource Hub](/teachers/resources), which includes lesson plans, exercises, activities, and writing prompts to encourage reflection and retention. We’re also making printable guides available for students to reference as they work through levels. In addition, we provide level solutions for every course so teachers can help spot and correct errors in students’ code as they come up.

### How much does it cost to access all of the available courses and resources?
We customize solutions for schools and districts and work with you to understand your use case, context, and budget. Contact schools@codecombat.com for further details!

### What does a license provide?
A license provides a single student access to the entire curriculum beyond the trial course (Introduction to Computer Science).

### Do you have any free courses for educators to try before they make their purchasing decision?
Yes! Our Introduction to Computer Science course does not require student licenses.  It takes 1-3 hours depending on your students' ages and experience. Please feel free to try it out in your school or district. There is no limit to the amount of students who can participate!

### Can my students create an account if they have no email address?
Yes - students signing up with a Class Code or a Class URL are given the option to choose a Username and skip the email field (it's labeled as "Optional"). Please refer to [Teacher Getting Started Guide](/teachers/resources/getting-started) more information about adding students to your class .

### Can I track my student’s progress?
Yes - the Teacher Dashboard provides detailed student progress, completion time and overall class statistics, and also allows you to assign manage student course assignments.

### Does CodeCombat work on an iPad?
We do not currently support iPads or Android Tablets at this time.

### Does CodeCombat support Clever Instant Logins?
Yes! Check our our [Clever Integration FAQ](/teachers/resources/clever-faq) for more details on how to get started.

### Is there a recommended browser and operating system?
CodeCombat runs best on computers with at least 4GB of RAM, on a modern browser such as Chrome, Safari, Firefox, or Edge. Chromebooks with 2GB of RAM may have minor graphics issues in later courses. A minimum of 200 Kbps bandwidth per student is required, although 1+ Mbps is recommended.

### Students’ computer science backgrounds vary differently in my class, how does CodeCombat help me with that challenge?
Many teachers are facing the challenge to address different student needs in the classroom. You are not alone there. CodeCombat solves your problem by providing truly personalized learning experience to your students.

We know that different students learn at different paces, and sometimes they may need extra assistance with new concepts. We’ve built two new features to help smooth out the learning curve of students who find themselves stuck: Hints, and Practice Levels.

**Hints**
Hints come in handy when students are struggling with a specific level. Every level has a blue “Hints” button at the top right corner, which gives a more in-depth explanation of the level’s specific concepts and provides additional step by step examples of how to complete it.

**Practice Levels**
The second feature is Practice Levels, which helps students get more experience with a particular concept if they are struggling. When the game detects that a student has struggled with a level, the game adapts so the student has more opportunity to practice the same skill until they improve. This provides a personalized learning experience for each student, so they can move past concepts they understand quickly, and get more practice for concepts that are challenging.

### What if I need licenses that only last a semester instead of a full year?
The standard Student License term is for one year, but it can be broken into semesters as needed. Just talk to one of our [School Specialists](mailto:schools@codecombat.com) to discuss your needs.

### What is the Arena level at the end of a course?
[Arenas](/teachers/resources/arenas) are open practice levels where students can hone the skills they learned in each course. You may use the arena to let faster students explore a deeper multiplayer strategy while the slower students catch up, and then when everyone is at the arena level, optionally have some class time for an in-class tournament. That way you can assign the next course to all students at the same time so that everyone stays roughly in sync within a course.

See the [Arena Levels Guide](/teachers/resources/arenas) for more details.

### Does CodeCombat have projects that students can work on and share?
Our game development and web development courses are all project-based! Teachers and students love those courses because they get to be the ‘creator’ in those projects. At the end of these courses they will also be able to showcase their projects by sharing permanent project links.

### What do you offer in the Web Development and Game Development courses?
**Web Development**
In our Web Development courses, students learn the fundamentals of building
interactive websites using HTML, CSS, and JavaScript. All webpages are automatically published to a custom URL so that students can easily share their finished project with friends and family. Check out this example poster by one of the students from our summer coding camp -- the result of just an hour’s work by a student who had no prior experience with web development!

**Game Development**
What’s even more fun than playing a game? Making your own! In our Game Development courses, students learn how to build their own CodeCombat-style game levels and unleash them on friends and family to play with a mouse and keyboard. Over time, they’ll unlock the tools needed to create challenging puzzles and practice their game design skills to become the next star game designer. Final projects for each course can be shared are published to a custom URL so that students can easily share their games with friends and family.

Teachers can preview all Web and Game Development levels by going to the [Course Guides](/teachers/courses) page and selecting a level from the dropdown menus.

### Can students skip earlier levels if they already understand the concepts?
We strongly encourage that all students play every level even if they already know the concepts, so that they can reinforce their knowledge. The levels are carefully planned out to build confidence and progress in a logical way, and it’s a chance for the students to become familiar with the platform, the user experience, and the basic logic behind our game-play so they know how to tackle the harder, more advanced courses.

Teachers can assign courses at their discretion, but we recommend that your students work through courses in the suggested order.

### Does the teacher need to purchase a license if they want to work through the levels like their students?
No. Teachers can preview and play all game levels by going to the [Course Guides](/teachers/courses) page and selecting a level from the dropdown menus.  Level progress is not saved.

### How do I get started with CodeCombat?
To get started:
1. Create your Teacher Account
2. Create a class.
3. Add students.
4. Sit back and watch your students have fun learning to code.

Please refer to [Teacher Getting Started Guide](/teachers/resources/getting-started) for instructions on each step .

### Is there a limit to how many students I can add in Introduction to Computer Science?
No.

### How do I reset my student's password?
As an instructor, you can reset the password for any students who have not verified their email address (or if they haven't provided an email address). To do so, go to that student's class, find the student in the list of students, and click "Edit" on the right side of the student's row.

If your student has verified their email, they will need to use the 'Forgot your password?' link in the Log In pop-up to reset their password.

### How do I transfer a license from one student to another?

A Full License can be removed from a student at any time before the license expires, and assigned to another student. To do so, go to that student's class, click the "License Status" tab, and click "Revoke License" from the student you wish to revoke the license from. This student will not be able to play any new levels that require a license (they will still be able to access any levels they've already started). The license will be available to assign to another student (the license expiration date will remain the same) -- see the [Student Licenses](/teachers/licenses) page for all of your available licenses.

### How do I share licenses to other teachers in my organization?
If you have Full Licenses, you can share access to them with other teachers in your organization. Navigate to the [Student Licenses tab](/teachers/licenses), then click the "Share Licenses" link below any group of licenses. This will popup a dialog that allows you to add teachers to the shared licenses.

You can only add teachers in your organization that have already created a Teacher Account ([here's how](/teachers/resources/getting-started)). Once a teacher has been added to a shared license pool, they have the ability to use any of the licenses you've shared.

When a license has been used, it is not available to be used by another teacher until that teacher revokes the license from the student (see [How to Transfer a License](#how-do-i-transfer-a-license-from-one-student-to-another)).

### How do I assess my students’ grasp of concepts? 
Students are provided with assessment opportunities in the form of Challenge Levels, which are optional levels that students unlock as they play the required levels in Computer Science courses. 

Teachers can view their student’s assessments in the new Assessments tab in each classroom. Challenge levels are currently available in Introduction to Computer Science and Computer Science 2. We will be adding additional challenge levels for Computer Science 3 and beyond in the coming months. 

Classrooms created anytime after August 2017 will automatically have Assessments available. If you created your classroom before August 2017, we recommend creating a new class in order for your students to be able to play the challenge levels. If you need assistance, feel free to reach out to schools@codecombat.com. 


### What is the difference between the two Challenge Level types?
Concept Challenge levels are unlocked when students complete all levels associated with a new concept and are designed to function as formative check-ins, similar to an exit ticket. 

Combo Challenge levels are unlocked when students have learned 2-4 new concepts and are designed to function summatively, similar to a short end-of-unit quiz. Combo Challenges can be passed as long as students use at least one of the possible concepts; multiple solutions are provided as examples to teachers. 

### How do I review my students’ level code?
Teachers can compare each student’s level code to CodeCombat’s solution code by navigating to the Course Progress tab in their classroom and clicking on any of their students’ green (level completed) or yellow (level in-progress) progress dots.

### Where can I find the solutions to all levels?

Solutions to each level (including Challenge Levels) can be found in the [Course Guides](/teachers/courses) page -- to view the solutions, navigate to a course, then click the Level Solutions guide for either JavaScript or Python (or HTML in the case of Web Development). 

All teachers have access to solutions for Introduction to Computer Science. Teachers who have paid student licenses have access to solutions for all courses. 

[Back to Top](#site-content-area)
